package com.hfkj.dao;

import com.hfkj.entity.GoodsMsg;
import com.hfkj.entity.GoodsMsgExample.Criteria;
import com.hfkj.entity.GoodsMsgExample.Criterion;
import com.hfkj.entity.GoodsMsgExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class GoodsMsgSqlProvider {

    public String countByExample(GoodsMsgExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("goods_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(GoodsMsgExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("goods_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(GoodsMsg record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("goods_msg");
        
        if (record.getGoodsType() != null) {
            sql.VALUES("goods_type", "#{goodsType,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeName() != null) {
            sql.VALUES("goods_type_name", "#{goodsTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsTypeParent() != null) {
            sql.VALUES("goods_type_parent", "#{goodsTypeParent,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeParentName() != null) {
            sql.VALUES("goods_type_parent_name", "#{goodsTypeParentName,jdbcType=VARCHAR}");
        }
        
        if (record.getSaleNum() != null) {
            sql.VALUES("sale_num", "#{saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsBrandName() != null) {
            sql.VALUES("goods_brand_name", "#{goodsBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsBrand() != null) {
            sql.VALUES("goods_brand", "#{goodsBrand,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsLabel() != null) {
            sql.VALUES("goods_label", "#{goodsLabel,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsExplain() != null) {
            sql.VALUES("goods_explain", "#{goodsExplain,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.VALUES("title", "#{title,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.VALUES("list_img", "#{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.VALUES("banner_img", "#{bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailImg() != null) {
            sql.VALUES("detail_img", "#{detailImg,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(GoodsMsgExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("goods_type");
        sql.SELECT("goods_type_name");
        sql.SELECT("goods_type_parent");
        sql.SELECT("goods_type_parent_name");
        sql.SELECT("sale_num");
        sql.SELECT("`type`");
        sql.SELECT("goods_brand_name");
        sql.SELECT("goods_brand");
        sql.SELECT("goods_label");
        sql.SELECT("goods_explain");
        sql.SELECT("title");
        sql.SELECT("list_img");
        sql.SELECT("banner_img");
        sql.SELECT("detail_img");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("mer_id");
        sql.SELECT("mer_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("goods_msg");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        GoodsMsg record = (GoodsMsg) parameter.get("record");
        GoodsMsgExample example = (GoodsMsgExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("goods_msg");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{record.goodsType,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeName() != null) {
            sql.SET("goods_type_name = #{record.goodsTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsTypeParent() != null) {
            sql.SET("goods_type_parent = #{record.goodsTypeParent,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeParentName() != null) {
            sql.SET("goods_type_parent_name = #{record.goodsTypeParentName,jdbcType=VARCHAR}");
        }
        
        if (record.getSaleNum() != null) {
            sql.SET("sale_num = #{record.saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsBrandName() != null) {
            sql.SET("goods_brand_name = #{record.goodsBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsBrand() != null) {
            sql.SET("goods_brand = #{record.goodsBrand,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsLabel() != null) {
            sql.SET("goods_label = #{record.goodsLabel,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsExplain() != null) {
            sql.SET("goods_explain = #{record.goodsExplain,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.SET("banner_img = #{record.bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailImg() != null) {
            sql.SET("detail_img = #{record.detailImg,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("goods_msg");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("goods_type = #{record.goodsType,jdbcType=BIGINT}");
        sql.SET("goods_type_name = #{record.goodsTypeName,jdbcType=VARCHAR}");
        sql.SET("goods_type_parent = #{record.goodsTypeParent,jdbcType=BIGINT}");
        sql.SET("goods_type_parent_name = #{record.goodsTypeParentName,jdbcType=VARCHAR}");
        sql.SET("sale_num = #{record.saleNum,jdbcType=INTEGER}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("goods_brand_name = #{record.goodsBrandName,jdbcType=VARCHAR}");
        sql.SET("goods_brand = #{record.goodsBrand,jdbcType=BIGINT}");
        sql.SET("goods_label = #{record.goodsLabel,jdbcType=VARCHAR}");
        sql.SET("goods_explain = #{record.goodsExplain,jdbcType=VARCHAR}");
        sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        sql.SET("banner_img = #{record.bannerImg,jdbcType=VARCHAR}");
        sql.SET("detail_img = #{record.detailImg,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        GoodsMsgExample example = (GoodsMsgExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(GoodsMsg record) {
        SQL sql = new SQL();
        sql.UPDATE("goods_msg");
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{goodsType,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeName() != null) {
            sql.SET("goods_type_name = #{goodsTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsTypeParent() != null) {
            sql.SET("goods_type_parent = #{goodsTypeParent,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsTypeParentName() != null) {
            sql.SET("goods_type_parent_name = #{goodsTypeParentName,jdbcType=VARCHAR}");
        }
        
        if (record.getSaleNum() != null) {
            sql.SET("sale_num = #{saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsBrandName() != null) {
            sql.SET("goods_brand_name = #{goodsBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsBrand() != null) {
            sql.SET("goods_brand = #{goodsBrand,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsLabel() != null) {
            sql.SET("goods_label = #{goodsLabel,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsExplain() != null) {
            sql.SET("goods_explain = #{goodsExplain,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{title,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getBannerImg() != null) {
            sql.SET("banner_img = #{bannerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getDetailImg() != null) {
            sql.SET("detail_img = #{detailImg,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, GoodsMsgExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}